/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.isobus.type;

import nl.cloudfarming.client.isobus.model.IsobusTreatmentZone;


/**
 * Class which can be used to store a grid in
 * This grid contains IsobusTreatmentZones
 * 
 * @author Merijn Zengers
 * @deprecated use IsobusValueGrid
 */
@Deprecated
public class IsobusTreatmentZoneGrid {
    private IsobusTreatmentZone[][] grid;
    private int numberOfColumn;
    private int numberOfRows;
    
    public IsobusTreatmentZoneGrid(int numberOfRows, int numberOfColumn){
        grid = new IsobusTreatmentZone[numberOfRows][numberOfColumn];
        this.numberOfRows = numberOfRows;
        this.numberOfColumn = numberOfColumn;
    }
    
    /**
     * Inserts a IsobusTreatmentZone at the specified row and column
     * Take notice!! this will replace the value current on this row column if there is any 
     * @param column
     * @param row
     * @param treatmentZone 
     */
    public void insert(int row, int column, IsobusTreatmentZone treatmentZone){
        grid[row][column] = treatmentZone;
    }
    
    /**
     * Get the IsobusTreatmentZone 
     * @param column
     * @param row
     * @return 
     */
    public IsobusTreatmentZone getTreatmentZone(int row, int column){
        return grid[row][column];
    }
    
    /**
     * Gets a row from the grid
     * @param rowNum
     * @return 
     */
    public IsobusTreatmentZone[] getRow(int rowNum){
        return grid[rowNum];
    }
        
    
    /**
     * Get the number of columns in this grid
     * @return 
     */
    public int getNumberOfColumn() {
        return numberOfColumn;
    }

    /**
     * Get the number of rows for this grid 
     * @return 
     */
    public int getNumberOfRows() {
        return numberOfRows;
    }
    
    public int getSize(){
        return numberOfColumn * numberOfRows;
    }
    
    
    
    
}
